//package xml;

import org.w3c.dom.*;
import java.util.Vector;
import java.util.Hashtable;
import java.util.Enumeration;
import java.util.Stack;
import java.io.PrintStream;
import java.net.*;


/**
*
* @date   July 26, 1999 ( Last Updated July 26, 1999 )
* @author H. Timucin Ozdemir
*
*/
public class BaseDocument implements XMLDebugFlags {

   public static String 
   makeAbsoluteURL (String url) throws MalformedURLException
   {
      URL baseURL;
      String currentDirectory = System.getProperty("user.dir");
      String fileSep = System.getProperty("file.separator");
      String file = currentDirectory.replace(fileSep.charAt(0), '/') + '/';
      if (file.charAt(0) != '/') { file = "/" + file; }
      baseURL = new URL("file", null, file);
      return new URL(baseURL,url).toString();

   }// end of makeAbsoluteURL()

   String getTextNodeValue(Element current) {
     String ret=null;if(DEBUG) System.out.println(" in getTextNodeValue() "+current.getTagName());
     if( current!=null && current.getNodeType()==org.w3c.dom.Node.ELEMENT_NODE ) {
        NodeList bList = current.getChildNodes() ;
        if(bList!=null && bList.getLength()>0) {
          Node current2 = (Node)bList.item(0);
          if( current2!=null && current2.getNodeType()==org.w3c.dom.Node.TEXT_NODE )  
              ret = new String(((Text)current2).getData()); 
        }// end of if
     }// end of if
     if(DEBUG) System.out.println(" out of getTextNodeValue() "+current.getTagName()+"="+ret);
     return ret; 
   }// end of getTextNodeValue()

   String getAttributeValue(Element current, String attName) {
     String ret=null;if(DEBUG) System.out.println(" in getAttributeValue() ");
     if( current!=null && attName!=null && current.getNodeType()==org.w3c.dom.Node.ELEMENT_NODE ) {
        org.w3c.dom.NamedNodeMap attribs = current.getAttributes();
        org.w3c.dom.Attr a1 = (org.w3c.dom.Attr) attribs.getNamedItem(attName);
        if(a1!=null) ret = new String(a1.getValue());
     }// end of if
     if(DEBUG) System.out.println(" out getAttributeValue() "+attName+"="+ret);
     return ret; 
   }// end of getAttributeValue()

   public static String getAttrValue(Element current, String attName) {
     String ret=null;if(DEBUG) System.out.println(" in getAttributeValue() ");
     if( current!=null && attName!=null && current.getNodeType()==org.w3c.dom.Node.ELEMENT_NODE ) {
        org.w3c.dom.NamedNodeMap attribs = current.getAttributes();
        org.w3c.dom.Attr a1 = (org.w3c.dom.Attr) attribs.getNamedItem(attName);
        if(a1!=null) ret = new String(a1.getValue());
     }// end of if
     if(DEBUG) System.out.println(" out getAttributeValue() "+attName+"="+ret);
     return ret; 
   }// end of getAttributeValue()

   public static String getTXTNodeValue(Element current) {
     String ret=null;if(DEBUG) System.out.println(" in getTextNodeValue() "+current.getTagName());
     if( current!=null && current.getNodeType()==org.w3c.dom.Node.ELEMENT_NODE ) {
        NodeList bList = current.getChildNodes() ;
        if(bList!=null && bList.getLength()>0) {
          Node current2 = (Node)bList.item(0);
          if( current2!=null && current2.getNodeType()==org.w3c.dom.Node.TEXT_NODE )  
              ret = new String(((Text)current2).getData()); 
        }// end of if
     }// end of if
     if(DEBUG) System.out.println(" out of getTextNodeValue() "+current.getTagName()+"="+ret);
     return ret; 
   }// end of getTXTNodeValue()

}// end of BaseDocument
